
let produits = Dir.create_printable_directory ()

class produit titre genre prix = object (self)
  initializer produits#add_item titre (self:>produit)
  method titre = titre
  method prix = prix
  method genre = genre
  method to_string =
    Printf.sprintf "%s à %d€" genre prix
end

let disques = Dir.create_printable_directory ()
let () =
  produits#add_directory "Disques" (disques :> produit Dir.printable_ro_directory)

class disque titre artiste prix = object (self)
  initializer disques#add_item titre (self:>disque)
  inherit produit titre "disques" prix
  method artiste = artiste
  method to_string =
    Printf.sprintf "disque de %s à %d€" artiste prix
end

let () =
  ignore (new produit "Truc Tour" "place de concert" 42) ;
  ignore (new produit "Bob Marley" "poster" 5) ;
  ignore (new disque "Fashion Nugget" "Cake" 12) ;
  ignore (new disque "At the Pershing" "Ahmad Jamal" 19) ;
  ignore (new disque "Chamboultou" "Têtes Raides" 9)

let () =
  let pp = new Dir.terminal_pp in
    pp#open_section "Produits" ;
    produits#print pp ;
    pp#close_section

let () =
  Printf.printf "\nProduits à moins de 10€:\n" ;
  produits#iter
    (fun p ->
       if p#prix < 10 then
         Printf.printf " -> %s: %s\n" p#titre p#to_string) ;
  Printf.printf "\nDisques de Cake:\n" ;
  disques#iter
    (fun p ->
       if p#artiste = "Cake" then
         Printf.printf " -> %s: %s\n" p#titre p#to_string)
